/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package views;

import javax.swing.JOptionPane;
import controllers.LibroController;
import controllers.EditorialController;
import controllers.CategoriaController;
import controllers.AutorController;
import java.awt.Component;
import java.lang.reflect.Array;
import java.util.ArrayList;
import javax.swing.DefaultListCellRenderer;
import javax.swing.DefaultListModel;
import javax.swing.JLabel;
import javax.swing.JList;
import java.lang.Integer;
/**
 *
 * @author jaimearroyo
 */
public class LibroEditNew extends javax.swing.JFrame {
    LibroController libro = new LibroController();
    /**
     * Creates new form CategoryNewEdit y ademas reescribe los metodos de render de los jselect y jlist
     */
    public LibroEditNew() {
        initComponents();
        EditorialController.index().forEach((p) -> {
             //combo_editorial.insertItemAt(p[1].toString(), Integer.parseInt(p[0].toString()));
             combo_editorial.addItem(p);
        });
        
        
        combo_editorial.setRenderer(new DefaultListCellRenderer() {
            @Override
            public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
                super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
                if(value instanceof Object){
                    Object[] lib = (Object[]) value;
                    setText(lib[1].toString());
                }
                return this;
            }
        } );
        
        DefaultListModel model = new DefaultListModel();
        CategoriaController.index().forEach((p) -> {
            model.addElement(p);
        });
        
        list_categorias.setModel(model);

        list_categorias.setCellRenderer(new DefaultListCellRenderer() {
            @Override
            public Component getListCellRendererComponent(JList<?> list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
                Component renderer = super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
                if(value instanceof Object){
                    Object[] lib = (Object[]) value;
                    setText(lib[1].toString());
                }
                return renderer;
            }
        }); 
        
         DefaultListModel model_autors = new DefaultListModel();
         AutorController.index().forEach((p) -> {
            model_autors.addElement(p);
        });
         
        list_autores.setModel(model_autors);

        list_autores.setCellRenderer(new DefaultListCellRenderer() {
            @Override
            public Component getListCellRendererComponent(JList<?> list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
                Component renderer = super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
                if(value instanceof Object){
                    Object[] lib = (Object[]) value;
                    setText(lib[1].toString());
                }
                return renderer;
            }
        });  
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        header_category = new javax.swing.JLabel();
        label_name_cat = new javax.swing.JLabel();
        txt_isbn = new javax.swing.JTextField();
        boton_guardar = new javax.swing.JButton();
        boton_listado = new javax.swing.JButton();
        label_accion = new javax.swing.JLabel();
        label_name_cat1 = new javax.swing.JLabel();
        txt_titulo = new javax.swing.JTextField();
        label_name_cat2 = new javax.swing.JLabel();
        txt_num_paginas = new javax.swing.JTextField();
        label_name_cat3 = new javax.swing.JLabel();
        txt_precio = new javax.swing.JTextField();
        label_name_cat4 = new javax.swing.JLabel();
        txt_anio = new javax.swing.JTextField();
        label_name_cat5 = new javax.swing.JLabel();
        combo_editorial = combo_editorial = new javax.swing.JComboBox<Object[]>();
        label_name_cat6 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        list_categorias = new javax.swing.JList<>();
        label_name_cat7 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        list_autores = new javax.swing.JList<>();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        header_category.setFont(new java.awt.Font("Lucida Grande", 0, 18)); // NOI18N
        header_category.setText("Libros");

        label_name_cat.setFont(new java.awt.Font("Lucida Grande", 0, 14)); // NOI18N
        label_name_cat.setText("ISBN");

        txt_isbn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txt_isbnActionPerformed(evt);
            }
        });

        boton_guardar.setText("Guardar");
        boton_guardar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                boton_guardarActionPerformed(evt);
            }
        });

        boton_listado.setText("Listado de libros");
        boton_listado.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                boton_listadoActionPerformed(evt);
            }
        });

        label_accion.setText("Ingresar nuevo libro");
        label_accion.setToolTipText("");

        label_name_cat1.setFont(new java.awt.Font("Lucida Grande", 0, 14)); // NOI18N
        label_name_cat1.setText("Titulo");

        txt_titulo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txt_tituloActionPerformed(evt);
            }
        });

        label_name_cat2.setFont(new java.awt.Font("Lucida Grande", 0, 14)); // NOI18N
        label_name_cat2.setText("Nº Páginas");

        txt_num_paginas.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txt_num_paginasActionPerformed(evt);
            }
        });

        label_name_cat3.setFont(new java.awt.Font("Lucida Grande", 0, 14)); // NOI18N
        label_name_cat3.setText("Precio ref.");

        txt_precio.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txt_precioActionPerformed(evt);
            }
        });

        label_name_cat4.setFont(new java.awt.Font("Lucida Grande", 0, 14)); // NOI18N
        label_name_cat4.setText("Año");

        txt_anio.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txt_anioActionPerformed(evt);
            }
        });

        label_name_cat5.setFont(new java.awt.Font("Lucida Grande", 0, 14)); // NOI18N
        label_name_cat5.setText("Editorial");

        label_name_cat6.setFont(new java.awt.Font("Lucida Grande", 0, 14)); // NOI18N
        label_name_cat6.setText("Categorias");

        jScrollPane1.setViewportView(list_categorias);

        label_name_cat7.setFont(new java.awt.Font("Lucida Grande", 0, 14)); // NOI18N
        label_name_cat7.setText("Autores");

        jScrollPane2.setViewportView(list_autores);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(133, 133, 133)
                        .addComponent(label_accion))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(158, 158, 158)
                        .addComponent(header_category))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(34, 34, 34)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 214, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(label_name_cat1)
                                    .addComponent(label_name_cat)
                                    .addComponent(label_name_cat2)
                                    .addComponent(label_name_cat3)
                                    .addComponent(label_name_cat4)
                                    .addComponent(label_name_cat5)
                                    .addComponent(label_name_cat6)
                                    .addComponent(label_name_cat7))
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addGroup(layout.createSequentialGroup()
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                            .addComponent(txt_titulo)
                                            .addComponent(txt_isbn)
                                            .addComponent(txt_num_paginas, javax.swing.GroupLayout.DEFAULT_SIZE, 214, Short.MAX_VALUE)
                                            .addComponent(txt_precio, javax.swing.GroupLayout.DEFAULT_SIZE, 214, Short.MAX_VALUE)
                                            .addComponent(txt_anio, javax.swing.GroupLayout.DEFAULT_SIZE, 214, Short.MAX_VALUE)
                                            .addComponent(combo_editorial, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 214, javax.swing.GroupLayout.PREFERRED_SIZE))))
                            .addComponent(boton_guardar, javax.swing.GroupLayout.PREFERRED_SIZE, 180, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(boton_listado, javax.swing.GroupLayout.PREFERRED_SIZE, 180, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap(116, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(header_category)
                .addGap(17, 17, 17)
                .addComponent(label_accion, javax.swing.GroupLayout.PREFERRED_SIZE, 16, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(label_name_cat)
                    .addComponent(txt_isbn, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(label_name_cat1)
                    .addComponent(txt_titulo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(label_name_cat2)
                    .addComponent(txt_num_paginas, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(label_name_cat3)
                    .addComponent(txt_precio, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(label_name_cat4)
                    .addComponent(txt_anio, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(label_name_cat5)
                    .addComponent(combo_editorial, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(label_name_cat6)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 49, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(14, 14, 14)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(label_name_cat7)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 49, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 23, Short.MAX_VALUE)
                .addComponent(boton_guardar, javax.swing.GroupLayout.PREFERRED_SIZE, 48, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(boton_listado, javax.swing.GroupLayout.PREFERRED_SIZE, 58, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        pack();
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void txt_isbnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txt_isbnActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_txt_isbnActionPerformed
/**
 * Captura acción click del boton guardar, toma los valores de los campos se los pasa al controlador, ademas obtienes los objectos seleccionados en las listas
 * de autores y categorias que son pasados como id's al controlador
 * @param evt evento click en el botón
 */
    private void boton_guardarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_boton_guardarActionPerformed
            
            int[] selected_categorias_ids = list_categorias.getSelectedIndices();
            ArrayList<Integer> ids_categorias = new ArrayList<>();
            for(int i = 0; i<selected_categorias_ids.length; i++){
                Object[] obj_cat = list_categorias.getModel().getElementAt(selected_categorias_ids[i]);
                ids_categorias.add(Integer.parseInt(obj_cat[0].toString()));
            }


            int[] selected_autores_ids = list_autores.getSelectedIndices();
            ArrayList<Integer> ids_autores = new ArrayList<>();
            for(int i = 0; i<selected_autores_ids.length; i++){
                Object[] obj_cat = list_autores.getModel().getElementAt(selected_autores_ids[i]);
                ids_autores.add(Integer.parseInt(obj_cat[0].toString()));
            }
        
            if(!txt_isbn.getText().equals("") && !txt_titulo.getText().equals("")){
                    Object[] editorial = combo_editorial.getItemAt(combo_editorial.getSelectedIndex());
                    


                    
                    System.out.println(ids_categorias.toString());
                    System.out.println(ids_autores.toString());
                    libro.newone(
                                    txt_isbn.getText(), 
                                    txt_titulo.getText(),
                                    Integer.parseInt(txt_num_paginas.getText()), 
                                    Float.parseFloat(txt_precio.getText()), 
                                    Integer.parseInt(txt_anio.getText()), 
                                    Integer.parseInt(editorial[0].toString()),
                                    ids_categorias,
                                    ids_autores
                    );
                    if(libro.save() != -1){
                        JOptionPane.showMessageDialog(null, "Registro guardado/actualziado correctamente");
                        this.ir_a_listado();
                    }else{
                        JOptionPane.showMessageDialog(null, "Error al insertar/actualizar, vuelva a intentar");
                    }

            }else{
                JOptionPane.showMessageDialog(null, "Debes llenar todos los campos");
            }

    }//GEN-LAST:event_boton_guardarActionPerformed
/**
 * Evento click en el boton volver al listado, ejecuta el metodo ir_a_listado de la clase
 * @param evt evento click del boton
 */
    private void boton_listadoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_boton_listadoActionPerformed
        this.ir_a_listado();
    }//GEN-LAST:event_boton_listadoActionPerformed

    private void txt_tituloActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txt_tituloActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_txt_tituloActionPerformed

    private void txt_num_paginasActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txt_num_paginasActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_txt_num_paginasActionPerformed

    private void txt_precioActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txt_precioActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_txt_precioActionPerformed

    private void txt_anioActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txt_anioActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_txt_anioActionPerformed

    /**
     * Genera una vista de listado, oculta la actual y muesta la vista del listado generada
     */
    public void ir_a_listado(){
        LibroIndex index_libro =new LibroIndex();
        this.setVisible(false);
        index_libro.setVisible(true);
    }
    
    /**
     * Tiene como parametro una instancia de LibroController con lo que a la vista actual se le 
     * setean los valores del formulario y se modifican unas etiquetas, esto
     * se ejecuta solo cuando se esta editando
     * @param libro_controller instancia de LibroController 
     */
    public void set_libro_controller(LibroController libro_controller){
        this.libro = libro_controller;
        Object[] libro_obj = libro_controller.get_fields();
        txt_isbn.setText(libro_obj[1].toString());
        txt_titulo.setText(libro_obj[2].toString());
        txt_num_paginas.setText(libro_obj[3].toString());
        txt_precio.setText(libro_obj[4].toString());
        txt_anio.setText(libro_obj[5].toString());
        
                
                
        
        ArrayList<Integer> selected_categories = new ArrayList<>();
        for(int i = 0; i< list_categorias.getModel().getSize();i++){
            Object[] aux_list = list_categorias.getModel().getElementAt(i);
            ArrayList al1 = (ArrayList) libro_obj[7];
            if(al1.indexOf(aux_list[0]) != -1){
                selected_categories.add(i);
            }
        }
        
        
        
        int[] ret = new int[selected_categories.size()];
        for (int i=0; i < ret.length; i++)
        {
            ret[i] = selected_categories.get(i).intValue();
        }

        
        list_categorias.setSelectedIndices(ret);
        
        System.err.println(list_categorias.getSelectedIndices());
        
         ArrayList<Integer> selected_autores = new ArrayList<>();
        for(int i = 0; i< list_autores.getModel().getSize();i++){
            Object[] aux_list = list_autores.getModel().getElementAt(i);
            ArrayList al1 = (ArrayList) libro_obj[7];
            if(al1.indexOf(aux_list[0]) != -1){
                selected_autores.add(i);
            }
        }
        
        int[] ret2 = new int[selected_autores.size()];
        for (int i=0; i < ret.length; i++)
        {
            ret2[i] = selected_autores.get(i).intValue();
        }

        
        list_autores.setSelectedIndices(ret2);
        System.err.println(list_autores.getSelectedIndices());
        
        boton_guardar.setText("Actualizar");
        label_accion.setText("Editando libro id: "+libro_obj[0].toString());
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(LibroEditNew.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(LibroEditNew.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(LibroEditNew.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(LibroEditNew.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
       
        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new LibroEditNew().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton boton_guardar;
    private javax.swing.JButton boton_listado;
    private javax.swing.JComboBox<Object[]> combo_editorial;
    private javax.swing.JLabel header_category;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JLabel label_accion;
    private javax.swing.JLabel label_name_cat;
    private javax.swing.JLabel label_name_cat1;
    private javax.swing.JLabel label_name_cat2;
    private javax.swing.JLabel label_name_cat3;
    private javax.swing.JLabel label_name_cat4;
    private javax.swing.JLabel label_name_cat5;
    private javax.swing.JLabel label_name_cat6;
    private javax.swing.JLabel label_name_cat7;
    private javax.swing.JList<Object[]> list_autores;
    private javax.swing.JList<Object[]> list_categorias;
    private javax.swing.JTextField txt_anio;
    private javax.swing.JTextField txt_isbn;
    private javax.swing.JTextField txt_num_paginas;
    private javax.swing.JTextField txt_precio;
    private javax.swing.JTextField txt_titulo;
    // End of variables declaration//GEN-END:variables
}
